<template>
	<f7-page name="accountbanks" @page:beforein="onPageBeforeIn">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link>
            </f7-nav-left>
            <f7-nav-title class="show-small-title">Akun</f7-nav-title>
            <f7-nav-title-large>Rekening Bank</f7-nav-title-large>
            <f7-nav-right>
                <f7-link href="/account/banks/create/" icon-f7="add" color="smoothgray" icon-only></f7-link>
            </f7-nav-right>
		</f7-navbar>

		<!-- Page content-->       
        <f7-link @click="showActionSheet(bank)" href="#" class="display-block color-gray" v-for="bank in user.bank_accounts" v-bind:key="bank.id">
            <f7-card class="card-shadow">                    
                <f7-card-content :padding="true" style="background:#221E1F;border-radius:7px;">
                    <f7-row>
                        <f7-col width="70">
                            <span class="display-block">{{bank.bank.name}}</span>
                            <span v-if="bank.branch != ''" class="display-block no-margin">{{bank.branch}}</span>
                        </f7-col>
                        <f7-col width="30">
                            <img :src="require(`../assets/logo-bank/${bank.bank.code}.png`)" style="width:100%;">
                        </f7-col>
                    </f7-row>
                    <br>
                    <br>
                    <h3 class="display-block no-margin-bottom" style="letter-spacing:8px;overflow: hidden;text-overflow: ellipsis;white-space: nowrap;width: 300px;">{{ bank.account_number.masking() }}</h3>
                    <f7-row>
                        <f7-col width="80">                            
                            <h4 class="display-block font-normal text-uppercase" style="letter-spacing:7px;margin-top:10px;">{{ bank.account_name }}</h4>
                        </f7-col>
                        <f7-col width="20">
                            <img :src="require(`../assets/logo-bank/${cardType(bank.account_number)}.png`)" style="width:100%;margin-top:10px;">
                        </f7-col>
                    </f7-row>
                    
                </f7-card-content>                        
            </f7-card>
        </f7-link>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat, cardType } from '../js/utils';
export default {
    name: 'BankAccount',
    data(){
        return{};
    },
    computed: {
        ...mapGetters(['bgColors']),
        ...mapGetters('auth', ['user'])
    },
    methods: {
        dateFormat,
        cardType,
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            app.preloader.show('green');

            self.$store.dispatch('auth/getBankAccounts', {
                exclude: 'role.permissions,parents.childs,parents.role.permissions'
            }).then((response) => {
                app.preloader.hide();
            });
        },
        showActionSheet(bank){
            const self = this;
            const app = self.$f7;

            let buttons = [{
                text: bank.account_name+'<br>'+bank.account_number,
                label: true
            }, {
                text: 'Ubah',
                close: true,
                onClick: function(actions, e){
                    self.$f7router.navigate('/account/banks/edit/'+bank.id+'/', {
						ignoreCache: true
					});
                }
            }, {
                text: 'Hapus',
                close: true,
                onClick: function(actions, e){
                    app.dialog.confirm('Anda yakin ingin menghapus rekening bank ini?', function(){
                        app.preloader.show('green');
                        self.$store.dispatch('auth/deleteBankAccount', {
                            id: bank.id,
                            exclude: 'role.permissions,parents.childs,parents.role.permissions'
                        }).then((response)=>{
                            app.preloader.hide();
                            self.$f7router.refreshPage();
                        });
                    });
                }
            }, {
                text: 'Batal',
                color: 'red',
                close: true
            }];

            let actionSheet = app.actions.create({
                buttons: buttons
            }).open();
        }
    }   
}
</script>
